WinRas.RASENTRY (JNA API)
Description: declaration: package: com.sun.jna.platform.win32, interface: WinRas, class: RASENTRY

Package com.sun.jna.platform.win32

# Class WinRas.RASENTRY

java.lang.Object
com.sun.jna.Structure
com.sun.jna.platform.win32.WinRas.RASENTRY

Direct Known Subclasses:
  `WinRas.RASENTRY.ByReference`

Enclosing interface:
  WinRas

@FieldOrder({"dwSize","dwfOptions","dwCountryID","dwCountryCode","szAreaCode","szLocalPhoneNumber","dwAlternateOffset","ipaddr","ipaddrDns","ipaddrDnsAlt","ipaddrWins","ipaddrWinsAlt","dwFrameSize","dwfNetProtocols","dwFramingProtocol","szScript","szAutodialDll","szAutodialFunc","szDeviceType","szDeviceName","szX25PadType","szX25Address","szX25Facilities","szX25UserData","dwChannels","dwReserved1","dwReserved2","dwSubEntries","dwDialMode","dwDialExtraPercent","dwDialExtraSampleSeconds","dwHangUpExtraPercent","dwHangUpExtraSampleSeconds","dwIdleDisconnectSeconds","dwType","dwEncryptionType","dwCustomAuthKey","guidId","szCustomDialDll","dwVpnStrategy","dwfOptions2","dwfOptions3","szDnsSuffix","dwTcpWindowSize","szPrerequisitePbk","szPrerequisiteEntry","dwRedialCount","dwRedialPause","ipv6addrDns","ipv6addrDnsAlt","dwIPv4InterfaceMetric","dwIPv6InterfaceMetric","ipv6addr","dwIPv6PrefixLength","dwNetworkOutageTime"}) public static class WinRas.RASENTRY extends Structure
The RASENTRY structure describes a phone-book entry. The RasSetEntryProperties and RasGetEntryProperties functions use this structure to set and retrieve the properties of a phone-book entry.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `WinRas.RASENTRY.ByReference`

  ## Nested classes/interfaces inherited from class com.sun.jna.Structure

  `Structure.ByValue, Structure.FieldOrder, Structure.StructField`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `int`
  `dwAlternateOffset`
  Specifies the offset, in bytes, from the beginning of the structure to a list of consecutive null-terminated strings.
  `int`
  `dwChannels`
  Reserved for future use
  `int`
  `dwCountryCode`
  Specifies the country/region code portion of the phone number.
  `int`
  `dwCountryID`
  Specifies the TAPI country/region identifier.
  `int`
  `dwCustomAuthKey`
  This member is used for Extensible Authentication Protocol (EAP).
  `int`
  `dwDialExtraPercent`
  Specifies a percent of the total bandwidth available from the currently connected subentries.
  `int`
  `dwDialExtraSampleSeconds`
  Specifies the number of seconds that current bandwidth usage must exceed the threshold specified by dwDialExtraPercent before RAS dials an additional subentry.
  `int`
  `dwDialMode`
  Specifies whether RAS should dial all of this entry's multilink subentries when the entry is first connected.
  `int`
  `dwEncryptionType`
  The type of encryption to use with the connection.
  `int`
  `dwfNetProtocols`
  Specifies the network protocols to negotiate.
  `int`
  `dwfOptions`
  A set of bit flags that specify connection options.
  `int`
  `dwfOptions2`
  A set of bits that specify connection options.
  `int`
  `dwfOptions3`
  This parameter is reserved for future use.
  `int`
  `dwFrameSize`
  Specifies the IP address of a secondary WINS server to be used while this connection is active.
  `int`
  `dwFramingProtocol`
  Specifies the framing protocol used by the server.
  `int`
  `dwHangUpExtraPercent`
  Specifies a percent of the total bandwidth available from the currently connected subentries.
  `int`
  `dwHangUpExtraSampleSeconds`
  Specifies the number of seconds that current bandwidth usage must be less than the threshold specified by dwHangUpExtraPercent before RAS terminates an existing subentry connection.
  `int`
  `dwIdleDisconnectSeconds`
  Specifies the number of seconds after which the connection is terminated due to inactivity.
  `int`
  `dwIPv4InterfaceMetric`
  Sets the metric of the IPv4 stack for this interface.
  `int`
  `dwIPv6InterfaceMetric`
  Sets the metric of the IPv6 stack for this interface.
  `int`
  `dwIPv6PrefixLength`
  The length of the IPv6 address prefix in ipv6addr.
  `int`
  `dwNetworkOutageTime`
  Specifies the amount of time, in minutes, that IKEv2 packets will be retransmitted without a response before the connection is considered lost.
  `int`
  `dwRedialCount`
  Specifies the number of times RAS attempts to redial a connection.
  `int`
  `dwRedialPause`
  Specifies the number of seconds to wait between redial attempts.
  `int`
  `dwReserved1`
  Reserved.
  `int`
  `dwReserved2`
  Reserved.
  `int`
  `dwSize`
  Specifies the size, in bytes, of the RASENTRY structure.
  `int`
  `dwSubEntries`
  Specifies the number of multilink subentries associated with this entry.
  `int`
  `dwTcpWindowSize`
  Specifies the TCP window size for all TCP sessions that run over this connection.
  `int`
  `dwType`
  The type of phone-book entry.
  `int`
  `dwVpnStrategy`
  The VPN strategy to use when dialing a VPN connection.
  `Guid.GUID`
  `guidId`
  The GUID (Globally Unique Identifier) that represents this phone-book entry.
  `WinRas.RASIPADDR`
  `ipaddr`
  Specifies the IP address to be used while this connection is active.
  `WinRas.RASIPADDR`
  `ipaddrDns`
  Specifies the IP address of the DNS server to be used while this connection is active.
  `WinRas.RASIPADDR`
  `ipaddrDnsAlt`
  Specifies the IP address of a secondary or backup DNS server to be used while this connection is active.
  `WinRas.RASIPADDR`
  `ipaddrWins`
  Specifies the IP address of the WINS server to be used while this connection is active.
  `WinRas.RASIPADDR`
  `ipaddrWinsAlt`
  Specifies the IP address of a secondary WINS server to be used while this connection is active.
  `WinRas.RASIPV6ADDR`
  `ipv6addr`
  Specifies the client's IPv6 address negotiated by the server and the client.
  `WinRas.RASIPV6ADDR`
  `ipv6addrDns`
  Contains the IPv6 address of the preferred DNS.
  `WinRas.RASIPV6ADDR`
  `ipv6addrDnsAlt`
  Contains the IPv6 address of the alternate DNS.
  `char[]`
  `szAreaCode`
  Specifies the area code as a null-terminated string.
  `char[]`
  `szAutodialDll`
  Windows 2000 or later: This member is no longer supported.
  `char[]`
  `szAutodialFunc`
  Windows 2000 or later: This member is no longer supported.
  `char[]`
  `szCustomDialDll`
  A null-terminated string that contains the full path and file name for the dynamic link library (DLL) that implements the custom-dialing functions.
  `char[]`
  `szDeviceName`
  Contains a null-terminated string that contains the name of a TAPI device to use with this phone-book entry, for example, "XYZ Corp 28800 External".
  `char[]`
  `szDeviceType`
  Specifies a null-terminated string that indicates the RAS device type referenced by szDeviceName.
  `char[]`
  `szDnsSuffix`
  Pointer to a string that specifies the Domain Name Service (DNS) suffix for the connection.
  `char[]`
  `szLocalPhoneNumber`
  Specifies a null-terminated device-type specific destination string.
  `char[]`
  `szPrerequisiteEntry`
  Pointer to a null-terminated string that specifies a phone-book entry.
  `char[]`
  `szPrerequisitePbk`
  Pointer to a null-terminated string that specifies the full path and file name of a phone-book (PBK) file.
  `char[]`
  `szScript`
  Specifies a null-terminated string that contains the name of the script file.
  `char[]`
  `szX25Address`
  Contains a null-terminated string that identifies the X.25 address to which to connect .
  `char[]`
  `szX25Facilities`
  Contains a null-terminated string that specifies the facilities to request from the X.25 host at connection.
  `char[]`
  `szX25PadType`
  Contains a null-terminated string that identifies the X.25 PAD type.
  `char[]`
  `szX25UserData`
  Contains a null-terminated string that specifies additional connection information supplied to the X.25 host at connection.

  ### Fields inherited from class com.sun.jna.Structure

  `ALIGN_DEFAULT, ALIGN_GNUC, ALIGN_MSVC, ALIGN_NONE, CALCULATE_SIZE`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `RASENTRY()`
  `RASENTRY(Pointer memory)`

- ## Method Summary

  ### Methods inherited from class com.sun.jna.Structure

  `allocateMemory, allocateMemory, autoAllocate, autoRead, autoRead, autoWrite, autoWrite, cacheTypeInfo, calculateSize, clear, createFieldsOrder, createFieldsOrder, createFieldsOrder, createFieldsOrder, dataEquals, dataEquals, ensureAllocated, equals, fieldOffset, getAutoRead, getAutoWrite, getFieldList, getFieldOrder, getFields, getNativeAlignment, getNativeSize, getNativeSize, getPointer, getStringEncoding, getStructAlignment, hashCode, newInstance, newInstance, read, readField, readField, setAlignType, setAutoRead, setAutoSynch, setAutoWrite, setStringEncoding, size, sortFields, toArray, toArray, toString, toString, useMemory, useMemory, write, writeField, writeField, writeField`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### dwSize

    public int dwSize
    Specifies the size, in bytes, of the RASENTRY structure. Before calling RasSetEntryProperties or RasGetEntryProperties, set dwSize to sizeof(RASENTRY) to identify the version of the structure.

  - ### dwfOptions

    public int dwfOptions
    A set of bit flags that specify connection options. Set one or more of the following flags.

  - ### dwCountryID

    public int dwCountryID
    Specifies the TAPI country/region identifier. Use the RasGetCountryInfo function to enumerate country/region identifiers. This member is ignored unless the dwfOptions member specifies the RASEO_UseCountryAndAreaCodes flag.

  - ### dwCountryCode

    public int dwCountryCode
    Specifies the country/region code portion of the phone number. The country/region code must correspond to the country/region identifier specified by dwCountryID. If dwCountryCode is zero, the country/region code is based on the country/region identifier specified by dwCountryID. This member is ignored unless dwfOptions specifies the RASEO_UseCountryAndAreaCodes flag.

  - ### szAreaCode

    public char[] szAreaCode
    Specifies the area code as a null-terminated string. If the dialing location does not have an area code, specify an empty string (""). Do not include parentheses or other delimiters in the area code string. For example, "206" is a valid area code; "(206)" is not. This member is ignored unless the dwfOptions member specifies the RASEO_UseCountryAndAreaCodes flag.

  - ### szLocalPhoneNumber

    public char[] szLocalPhoneNumber
    Specifies a null-terminated device-type specific destination string. The following table describes the contents of the szLocalPhoneNumber member for various device types.

  - ### dwAlternateOffset

    public int dwAlternateOffset
    Specifies the offset, in bytes, from the beginning of the structure to a list of consecutive null-terminated strings. The last string is terminated by two consecutive null characters. The strings are alternate phone numbers that RAS dials in the order listed if the primary number (see szLocalPhoneNumber) fails to connect. The alternate phone number strings are ANSI or Unicode, depending on whether you use the ANSI or Unicode version of the structure.

  - ### ipaddr

    public WinRas.RASIPADDR ipaddr
    Specifies the IP address to be used while this connection is active. This member is ignored unless dwfOptions specifies the RASEO_SpecificIpAddr flag.

  - ### ipaddrDns

    public WinRas.RASIPADDR ipaddrDns
    Specifies the IP address of the DNS server to be used while this connection is active. This member is ignored unless dwfOptions specifies the RASEO_SpecificNameServers flag.

  - ### ipaddrDnsAlt

    public WinRas.RASIPADDR ipaddrDnsAlt
    Specifies the IP address of a secondary or backup DNS server to be used while this connection is active. This member is ignored unless dwfOptions specifies the RASEO_SpecificNameServers flag.

  - ### ipaddrWins

    public WinRas.RASIPADDR ipaddrWins
    Specifies the IP address of the WINS server to be used while this connection is active. This member is ignored unless dwfOptions specifies the RASEO_SpecificNameServers flag.

  - ### ipaddrWinsAlt

    public WinRas.RASIPADDR ipaddrWinsAlt
    Specifies the IP address of a secondary WINS server to be used while this connection is active. This member is ignored unless dwfOptions specifies the RASEO_SpecificNameServers flag.

  - ### dwFrameSize

    public int dwFrameSize
    Specifies the IP address of a secondary WINS server to be used while this connection is active. This member is ignored unless dwfOptions specifies the RASEO_SpecificNameServers flag.

  - ### dwfNetProtocols

    public int dwfNetProtocols
    Specifies the network protocols to negotiate. This member can be a combination of the following flags.

  - ### dwFramingProtocol

    public int dwFramingProtocol
    Specifies the framing protocol used by the server. PPP is the emerging standard. SLIP is used mainly in UNIX environments. This member can be one of the following flags.

  - ### szScript

    public char[] szScript
    Specifies a null-terminated string that contains the name of the script file. The file name should be a full path. This field is only used for analog dial-up connections.

  - ### szAutodialDll

    public char[] szAutodialDll
    Windows 2000 or later: This member is no longer supported. The szCustomDialDll member of the RASENTRY structure specifies the path to the custom-dial DLL. For more information on custom dialers, see RAS Custom Dialers.

  - ### szAutodialFunc

    public char[] szAutodialFunc
    Windows 2000 or later: This member is no longer supported. See RAS Custom Dialers for more information on custom dialers.

  - ### szDeviceType

    public char[] szDeviceType
    Specifies a null-terminated string that indicates the RAS device type referenced by szDeviceName. This member can be one of the following string constants.

  - ### szDeviceName

    public char[] szDeviceName
    Contains a null-terminated string that contains the name of a TAPI device to use with this phone-book entry, for example, "XYZ Corp 28800 External". To enumerate all available RAS-capable devices, use the RasEnumDevices function.

  - ### szX25PadType

    public char[] szX25PadType
    Contains a null-terminated string that identifies the X.25 PAD type. Set this member to "" unless the entry should dial using an X.25 PAD. The szX25PadType string maps to a section name in PAD.INF.

  - ### szX25Address

    public char[] szX25Address
    Contains a null-terminated string that identifies the X.25 address to which to connect . Set this member to "" unless the entry should dial using an X.25 PAD or native X.25 device.

  - ### szX25Facilities

    public char[] szX25Facilities
    Contains a null-terminated string that specifies the facilities to request from the X.25 host at connection. This member is ignored if szX25Address is an empty string ("").

  - ### szX25UserData

    public char[] szX25UserData
    Contains a null-terminated string that specifies additional connection information supplied to the X.25 host at connection. This member is ignored if szX25Address is an empty string ("").

  - ### dwChannels

    public int dwChannels
    Reserved for future use

  - ### dwReserved1

    public int dwReserved1
    Reserved. Must be zero.

  - ### dwReserved2

    public int dwReserved2
    Reserved. Must be zero.

  - ### dwSubEntries

    public int dwSubEntries
    Specifies the number of multilink subentries associated with this entry. When calling RasSetEntryProperties, set this member to zero. To add subentries to a phone-book entry, use the RasSetSubEntryProperties function.

  - ### dwDialMode

    public int dwDialMode
    Specifies whether RAS should dial all of this entry's multilink subentries when the entry is first connected. This member can be one of the following values.

  - ### dwDialExtraPercent

    public int dwDialExtraPercent
    Specifies a percent of the total bandwidth available from the currently connected subentries. RAS dials an additional subentry when the total bandwidth used exceeds dwDialExtraPercent percent of the available bandwidth for at least dwDialExtraSampleSeconds seconds.

  - ### dwDialExtraSampleSeconds

    public int dwDialExtraSampleSeconds
    Specifies the number of seconds that current bandwidth usage must exceed the threshold specified by dwDialExtraPercent before RAS dials an additional subentry.

  - ### dwHangUpExtraPercent

    public int dwHangUpExtraPercent
    Specifies a percent of the total bandwidth available from the currently connected subentries. RAS terminates (hangs up) an existing subentry connection when total bandwidth used is less than dwHangUpExtraPercent percent of the available bandwidth for at least dwHangUpExtraSampleSeconds seconds.

  - ### dwHangUpExtraSampleSeconds

    public int dwHangUpExtraSampleSeconds
    Specifies the number of seconds that current bandwidth usage must be less than the threshold specified by dwHangUpExtraPercent before RAS terminates an existing subentry connection.

  - ### dwIdleDisconnectSeconds

    public int dwIdleDisconnectSeconds
    Specifies the number of seconds after which the connection is terminated due to inactivity. Note that unless the idle time out is disabled, the entire connection is terminated if the connection is idle for the specified interval. This member can specify a number of seconds, or one of the following values.

  - ### dwType

    public int dwType
    The type of phone-book entry. This member can be one of the following types.

  - ### dwEncryptionType

    public int dwEncryptionType
    The type of encryption to use with the connection. The encryption is either provided by IPSec (for L2TP/IPSec connections) or by Microsoft Point-to-Point Encryption (MPPE). This member can be one of the following values.

  - ### dwCustomAuthKey

    public int dwCustomAuthKey
    This member is used for Extensible Authentication Protocol (EAP). This member contains the authentication key provided to the EAP vendor.

  - ### guidId

    public Guid.GUID guidId
    The GUID (Globally Unique Identifier) that represents this phone-book entry. This member is read-only.

  - ### szCustomDialDll

    public char[] szCustomDialDll
    A null-terminated string that contains the full path and file name for the dynamic link library (DLL) that implements the custom-dialing functions. This DLL should export Unicode versions of functions named RasCustomDial, RasCustomHangup, RasCustomEntryDlg, and RasCustomDialDlg. These functions should have prototypes RasCustomDialFn and RasCustomHangUpFn as defined in Ras.h, and RasCustomDialDlgFn and RasCustomEntryDlgFn as defined in Rasdlg.h.

  - ### dwVpnStrategy

    public int dwVpnStrategy
    The VPN strategy to use when dialing a VPN connection. This member can have one of the following values.

  - ### dwfOptions2

    public int dwfOptions2
    A set of bits that specify connection options. This member is a continuation of the bits specified in the dwfOptions member. Set one or more of the following bit flags.

  - ### dwfOptions3

    public int dwfOptions3
    This parameter is reserved for future use.

  - ### szDnsSuffix

    public char[] szDnsSuffix
    Pointer to a string that specifies the Domain Name Service (DNS) suffix for the connection. This string can be Unicode depending on the version of the structure you are using.

  - ### dwTcpWindowSize

    public int dwTcpWindowSize
    Specifies the TCP window size for all TCP sessions that run over this connection. Setting this value can increase the throughput of high-latency devices such as cellular phones.

  - ### szPrerequisitePbk

    public char[] szPrerequisitePbk
    Pointer to a null-terminated string that specifies the full path and file name of a phone-book (PBK) file. This phone-book file contains the entry specified by the szPrerequisiteEntry member. This member is used only for VPN connections.

  - ### szPrerequisiteEntry

    public char[] szPrerequisiteEntry
    Pointer to a null-terminated string that specifies a phone-book entry. This entry should exist in the phone-book file specified by the szPrerequisitePbk member. The szPrerequisteEntry member specifies an entry that RAS dials prior to establishing the connection specified by this RASENTRY structure. This member is used only for VPN connections.

  - ### dwRedialCount

    public int dwRedialCount
    Specifies the number of times RAS attempts to redial a connection.

  - ### dwRedialPause

    public int dwRedialPause
    Specifies the number of seconds to wait between redial attempts.

  - ### ipv6addrDns

    public WinRas.RASIPV6ADDR ipv6addrDns
    Contains the IPv6 address of the preferred DNS. A RASIPV6ADDR type is identical to a in6_addr structure.

  - ### ipv6addrDnsAlt

    public WinRas.RASIPV6ADDR ipv6addrDnsAlt
    Contains the IPv6 address of the alternate DNS. A RASIPV6ADDR type is identical to a in6_addr structure.

  - ### dwIPv4InterfaceMetric

    public int dwIPv4InterfaceMetric
    Sets the metric of the IPv4 stack for this interface.

  - ### dwIPv6InterfaceMetric

    public int dwIPv6InterfaceMetric
    Sets the metric of the IPv6 stack for this interface.

  - ### ipv6addr

    public WinRas.RASIPV6ADDR ipv6addr
    Specifies the client's IPv6 address negotiated by the server and the client.

  - ### dwIPv6PrefixLength

    public int dwIPv6PrefixLength
    The length of the IPv6 address prefix in ipv6addr.

  - ### dwNetworkOutageTime

    public int dwNetworkOutageTime
    Specifies the amount of time, in minutes, that IKEv2 packets will be retransmitted without a response before the connection is considered lost. Increase this value to support connection persistence during network outages.

- ## Constructor Details

  - ### RASENTRY

    public RASENTRY()

  - ### RASENTRY

    public RASENTRY(Pointer memory)